unit UnitMeasure05HowMuchLength;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,printers, Grids, Spin, Measure{Measure.pas};

type
  TFormMeasure05HowMuchLength = class(TForm)
    PrintDialog1: TPrintDialog;
    PrinterSetupDialog1: TPrinterSetupDialog;
    Label00: TLabel;
    LabelGappiNamae: TLabel;
    Label001: TLabel;
    LabelAnswer1: TLabel;
    LabelProjectName: TLabel;
    LabelHyoudai1: TLabel;
    LabelAnswer2: TLabel;
    LabelAnswer3: TLabel;
    LabelAnswer4: TLabel;
    LabelAnswer5: TLabel;
    LabelAnswer6: TLabel;
    Measure2: TMeasure;
    Measure3: TMeasure;
    Measure4: TMeasure;
    Measure5: TMeasure;
    Measure6: TMeasure;
    StringGrid1: TStringGrid;
    Measure1: TMeasure;
    PanelButtons: TPanel;
    ButtonNew: TButton;
    ButtonStart: TButton;
    ButtonPrinterSetup: TButton;
    ButtonPrintOut: TButton;
    GroupBoxStart: TGroupBox;
    ButtonRadioGroupStartClose: TButton;
    GroupBoxMeasure: TGroupBox;
    CheckBoxMarginHorizontal: TCheckBox;
    RadioGroupBackGroundColor: TRadioGroup;
    GroupBoxScale: TGroupBox;
    RadioGroupBoardCharacter: TRadioGroup;
    RadioGroupLine: TRadioGroup;
    GroupBoxMeasureRange: TGroupBox;
    LabelMeasureMax: TLabel;
    LabelMeasureMin: TLabel;
    SpinEditMeasureMax: TSpinEdit;
    SpinEditMeasureMin: TSpinEdit;
    GroupBoxRandom: TGroupBox;
    RadioGroupBarColor: TRadioGroup;
    GroupBoxLength: TGroupBox;
    RadioGroupDivisionRandom: TRadioGroup;
    GroupBoxMMRange: TGroupBox;
    LabelThermoMax: TLabel;
    LabelThermoMIn: TLabel;
    SpinEditMMMax: TSpinEdit;
    SpinEditMMMin: TSpinEdit;
    GroupBoxStartPoint: TGroupBox;
    LabelRange: TLabel;
    SpinEditWidth: TSpinEdit;
    SpinEditStandard: TSpinEdit;
    RadioGroupUnit: TRadioGroup;
    procedure FormCreate(Sender: TObject);
    procedure FormDblClick(Sender: TObject);
    procedure ButtonPrintOutClick(Sender: TObject);
    procedure RadioGroupDivisionRandomClick(Sender: TObject);
    procedure ButtonPrinterSetupClick(Sender: TObject);
    procedure ButtonRadioGroupStartCloseClick(Sender: TObject);
    procedure Renew(Sender: TObject);
    procedure ReDisplay(Sender: TObject);
    procedure ButtonStartClick(Sender: TObject);
    procedure RadioGroupBoardCharacterClick(Sender: TObject);
    procedure RadioGroupLineClick(Sender: TObject);
    procedure RadioGroupUnitClick(Sender: TObject);
    procedure RadioGroupBarColorClick(Sender: TObject);
    procedure SpinEditMMMinChange(Sender: TObject);
    procedure SpinEditMMMaxChange(Sender: TObject);
    procedure SpinEditMeasureMaxChange(Sender: TObject);
    procedure RadioGroupBackGroundColorClick(Sender: TObject);
    procedure CheckBoxMarginHorizontalClick(Sender: TObject);
    procedure SpinEditMeasureMinChange(Sender: TObject);
    procedure SpinEditStandardChange(Sender: TObject);
    procedure SpinEditWidthChange(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  FormMeasure05HowMuchLength: TFormMeasure05HowMuchLength;

var hours,minutes:integer;
    PenWidthBorderLine: integer;
    PenWidthScaleNoon: integer;
    PenWidthScale1Minutes: integer;
    PenWidthScale5Minutes: integer;
    PenWidthLongHand: integer;
    PenWidthShortHand: integer;
var px10,py10,px20,py20,px30,py30,px40,py40,px50,py50:integer;
var px11,py11,px21,py21,px31,py31,px41,py41,px51,py51:integer;

implementation

{$R *.DFM}

var division: integer;
var sCheckBoxMarginHorizontal,
    sRadioGroupBoardCharacter,
    sRadioGroupLine,
    sSpinEditMeasureMax,
    sSpinEditMeasureMin,
    sSpinEditMMMax,
    sSpinEditMMMin,
    sBoardColor,
    sRadioGroupRandom,
    sBarStartStandard,
    sBarStartWidth,
    sBarColor,
    sMeasureTypeUnitKind: string;

procedure TFormMeasure05HowMuchLength.FormCreate(Sender: TObject);
var c: integer;
begin
  sCheckBoxMarginHorizontal:='';
  sRadioGroupBoardCharacter:='';
  sRadioGroupLine:='';
  sSpinEditMeasureMax:='';
  sSpinEditMeasureMin:='';
  sSpinEditMMMax:='';
  sSpinEditMMMin:='';
  sRadioGroupRandom:='';
  sBarColor:='';
  sMeasureTypeUnitKind:='';
  sSpinEditMeasureMax:='`'+inttostr(SpinEditMeasureMax.value)+', ';
  sSpinEditMeasureMin:='ڐ͈̔:'+inttostr(SpinEditMeasureMin.value);
  sBarStartStandard:='_̎n_:'+inttostr(SpinEditStandard.value);
  sBarStartWidth:='}'+inttostr(SpinEditWidth.value);
  Color:= clWhite;

  BorderStyle:= bsSizeable;
  PrintScale:= poPrintToFit;
  Scaled:= True;

  PenWidthBorderLine:=1;
  PenWidthScaleNoon:=5;
  PenWidthScale1Minutes:=1;
  PenWidthScale5Minutes:=2;
  PenWidthLongHand:=6;
  PenWidthShortHand:=10;

  CheckBoxMarginHorizontal.Checked:=true;
  RadioGroupBoardCharacter.ItemIndex:=0;
  RadioGroupLine.ItemIndex:=0;
  RadioGroupUnit.itemIndex:=0;
  RadioGroupDivisionRandom.itemIndex:=1;
  RadioGroupBarColor.ItemIndex:=3;
  RadioGroupBackGroundColor.ItemIndex:=0;

  ButtonStart.Hide;
  Stringgrid1.Hide;
  Stringgrid1.EditorMode:= true;
  StringGrid1.ColWidths[0]:= 36;
  for c:=1 to 6 do stringgrid1.Cells[c,0]:=inttostr(c);
  for c:=1 to 6 do stringgrid1.Cells[c,1]:='0';
  for c:=1 to 6 do stringgrid1.Cells[c,2]:='0';

  Stringgrid1.Cells[0, 0]:='';
  StringGrid1.Cells[0, 1]:='';
  StringGrid1.Cells[0, 2]:='n_';

  renew(sender);
end;

procedure TFormMeasure05HowMuchLength.FormDblClick(Sender: TObject);
begin
  FormCreate(Sender);
end;

procedure TFormMeasure05HowMuchLength.ButtonPrinterSetupClick(Sender: TObject);
begin
  PrinterSetupDialog1.Execute;
end;

procedure TFormMeasure05HowMuchLength.ButtonPrintOutClick(Sender: TObject);
begin
  GroupBoxStart.Hide;
  PanelButtons.Hide;

  printer.Orientation:= poLandscape;//v^ZbgAbv_CAOʂAڂɉuɐݒ
  Printer.Title:=self.Text;
  Self.Print;

  PanelButtons.show;
  GroupBoxStart.Show;

  renew(sender);
end;

procedure TFormMeasure05HowMuchLength.RadioGroupDivisionRandomClick(Sender: TObject);
var sDivision: string;
begin
  case RadioGroupDivisionRandom.itemindex of
    0: begin
         division:= 1;
         sdivision:=':1mm, ';
       end;
    1: begin
         division:= 2;
         sdivision:=':2mm, ';
       end;
    2: begin
         division:= 5;
         sdivision:=':5mm, ';
       end;
    3: begin
         division:= 10;
         sdivision:=':10mm, ';
       end;
  end;
  SpinEditMMMin.Increment:=division;
  SpinEditMMMax.Increment:=division;
  SpinEditStandard.Increment:=division;
  SpinEditWidth.Increment:=division;
  if SpinEditMMMin.Value> division then SpinEditMMMin.Value:= 0;
  SpinEditMMMin.Value:= trunc(SpinEditMMMin.Value / division) * division;
  SpinEditMMMax.Value:= trunc(SpinEditMMMax.Value / division) * division;
  sRadioGroupRandom:={''+}sDivision;
  redisplay(sender);
  renew(sender);
end;

procedure TFormMeasure05HowMuchLength.ButtonRadioGroupStartCloseClick(Sender: TObject);
begin
  ButtonStart.Show;
  GroupBoxStart.hide;
end;

procedure TFormMeasure05HowMuchLength.ReDisplay(Sender: TObject);
begin
  LabelHyoudai1.Caption:= sCheckBoxMarginHorizontal+
                          sRadioGroupLine+
                          sRadioGroupBoardCharacter+
                          sSpinEditMeasureMin+
                          sSpinEditMeasureMax+
                          sBoardColor+
                          sSpinEditMMMin+
                          sSpinEditMMMax+
                          sRadioGroupRandom+
                          sBarStartStandard+
                          sBarStartWidth+
                          sBarColor+
                          sMeasureTypeUnitKind;
end;

procedure TFormMeasure05HowMuchLength.Renew(Sender: TObject);
var i: integer;
begin
  //
  randomize;
  for i:=1 to 6 do
  begin
    case RadioGroupDivisionRandom.ItemIndex of
      0:begin
          StringGrid1.Cells[i,1]:= inttostr(SpinEditMMMin.value+ random(SpinEditMMMax.Value-SpinEditMMMin.value+1-SpinEditStandard.Value-SpinEditWidth.value));
          StringGrid1.Cells[i,2]:= inttostr(SpinEditStandard.value+ random(SpinEditWidth.Value+1));
        end;
      1:begin
          StringGrid1.Cells[i,1]:= inttostr(SpinEditMMMin.value+ random(SpinEditMmMax.Value-SpinEditMMMin.value+1-SpinEditStandard.Value-SpinEditWidth.value) div 2*2);
          StringGrid1.Cells[i,2]:= inttostr(SpinEditStandard.value+ random(SpinEditWidth.Value+1) div 2*2);
        end;
      2:begin
          StringGrid1.Cells[i,1]:= inttostr(SpinEditMMMin.value+ random(SpinEditMMMax.Value-SpinEditMMMin.value+1-SpinEditStandard.Value-SpinEditWidth.value) div 5*5);
          StringGrid1.Cells[i,2]:= inttostr(SpinEditStandard.value+ random(SpinEditWidth.Value+1) div 5*5);
        end;
      3:begin
          StringGrid1.Cells[i,1]:= inttostr(SpinEditMmMin.value+ random(SpinEditMmMax.Value-SpinEditMMMin.value+1-SpinEditStandard.Value-SpinEditWidth.value) div 10*10);
          StringGrid1.Cells[i,2]:= inttostr(SpinEditStandard.value+ random(SpinEditWidth.Value+1) div 10*10);
        end;
      else StringGrid1.Cells[i,2]:= inttostr(0);
    end;
  end;
  //
  Measure1.BarLength:=strtoint(StringGrid1.Cells[1,1]);
  Measure2.BarLength:=strtoint(StringGrid1.Cells[2,1]);
  Measure3.BarLength:=strtoint(StringGrid1.Cells[3,1]);
  Measure4.BarLength:=strtoint(StringGrid1.Cells[4,1]);
  Measure5.BarLength:=strtoint(StringGrid1.Cells[5,1]);
  Measure6.BarLength:=strtoint(StringGrid1.Cells[6,1]);
  Measure1.BarStartPoint:=strtoint(Stringgrid1.Cells[1,2]);
  Measure2.BarStartPoint:=strtoint(Stringgrid1.Cells[2,2]);
  Measure3.BarStartPoint:=strtoint(Stringgrid1.Cells[3,2]);
  Measure4.BarStartPoint:=strtoint(Stringgrid1.Cells[4,2]);
  Measure5.BarStartPoint:=strtoint(Stringgrid1.Cells[5,2]);
  Measure6.BarStartPoint:=strtoint(Stringgrid1.Cells[6,2]);

  ReDisplay(Sender);
end;

procedure TFormMeasure05HowMuchLength.ButtonStartClick(Sender: TObject);
begin
  GroupBoxStart.show;
end;

procedure TFormMeasure05HowMuchLength.RadioGroupBoardCharacterClick(Sender: TObject);
begin
  case RadioGroupBoardCharacter.ItemIndex of
  0:begin
      Measure1.TypeCharacterCM:=cm01Continue;
      Measure2.TypeCharacterCM:=cm01Continue;
      Measure3.TypeCharacterCM:=cm01Continue;
      Measure4.TypeCharacterCM:=cm01Continue;
      Measure5.TypeCharacterCM:=cm01Continue;
      Measure6.TypeCharacterCM:=cm01Continue;
      sRadioGroupBoardCharacter:='ڐ̐EL:1cmƁAA, ';
    end;
  1:begin
      Measure1.TypeCharacterCM:=cm01New;
      Measure2.TypeCharacterCM:=cm01New;
      Measure3.TypeCharacterCM:=cm01New;
      Measure4.TypeCharacterCM:=cm01New;
      Measure5.TypeCharacterCM:=cm01New;
      Measure6.TypeCharacterCM:=cm01New;
      sRadioGroupBoardCharacter:='ڐ̐EL:1cmƁAXV, ';
    end;
  2:begin
      Measure1.TypeCharacterCM:=cm05Continue;
      Measure2.TypeCharacterCM:=cm05Continue;
      Measure3.TypeCharacterCM:=cm05Continue;
      Measure4.TypeCharacterCM:=cm05Continue;
      Measure5.TypeCharacterCM:=cm05Continue;
      Measure6.TypeCharacterCM:=cm05Continue;
      sRadioGroupBoardCharacter:='ڐ̐EL:5cmƁAA, ';
    end;
  3:begin
      Measure1.TypeCharacterCM:=cm05New;
      Measure2.TypeCharacterCM:=cm05New;
      Measure3.TypeCharacterCM:=cm05New;
      Measure4.TypeCharacterCM:=cm05New;
      Measure5.TypeCharacterCM:=cm05New;
      Measure6.TypeCharacterCM:=cm05New;
      sRadioGroupBoardCharacter:='ڐ̐EL:5cmƁAA, ';
    end;
  4:begin
      Measure1.TypeCharacterCM:=cm10;
      Measure2.TypeCharacterCM:=cm10;
      Measure3.TypeCharacterCM:=cm10;
      Measure4.TypeCharacterCM:=cm10;
      Measure5.TypeCharacterCM:=cm10;
      Measure6.TypeCharacterCM:=cm10;
      sRadioGroupBoardCharacter:='ڐ̐EL:10cm, ';
    end;
  5:begin
      Measure1.TypeCharacterCM:=cmSign;
      Measure2.TypeCharacterCM:=cmSign;
      Measure3.TypeCharacterCM:=cmSign;
      Measure4.TypeCharacterCM:=cmSign;
      Measure5.TypeCharacterCM:=cmSign;
      Measure6.TypeCharacterCM:=cmSign;
      sRadioGroupBoardCharacter:='ڐ̐EL:L, ';
    end;
  6:begin
      Measure1.TypeCharacterCM:=cmNone;
      Measure2.TypeCharacterCM:=cmNone;
      Measure3.TypeCharacterCM:=cmNone;
      Measure4.TypeCharacterCM:=cmNone;
      Measure5.TypeCharacterCM:=cmNone;
      Measure6.TypeCharacterCM:=cmNone;
      sRadioGroupBoardCharacter:='ڐ̐EL:Ȃ, ';
    end;
  end;
  if ((RadioGroupBoardCharacter.ItemIndex=5) or (RadioGroupBoardCharacter.ItemIndex=6)) then
  begin
    Measure1.MarginHorizontalRight:= 0; Measure1.MarginHorizontalLeft:= 0; Measure1.TypeFigureBothEnds:=fbeNone ; Measure1.TypeScaleBothEnds:=sbeNone ; Measure1.Left:=47; Measure1.Width:=800;
    Measure2.MarginHorizontalRight:= 0; Measure2.MarginHorizontalLeft:= 0; Measure2.TypeFigureBothEnds:=fbeNone ; Measure2.TypeScaleBothEnds:=sbeNone ; Measure2.Left:=47; Measure2.Width:=800;
    Measure3.MarginHorizontalRight:= 0; Measure3.MarginHorizontalLeft:= 0; Measure3.TypeFigureBothEnds:=fbeNone ; Measure3.TypeScaleBothEnds:=sbeNone ; Measure3.Left:=47; Measure3.Width:=800;
    Measure4.MarginHorizontalRight:= 0; Measure4.MarginHorizontalLeft:= 0; Measure4.TypeFigureBothEnds:=fbeNone ; Measure4.TypeScaleBothEnds:=sbeNone ; Measure4.Left:=47; Measure4.Width:=800;
    Measure5.MarginHorizontalRight:= 0; Measure5.MarginHorizontalLeft:= 0; Measure5.TypeFigureBothEnds:=fbeNone ; Measure5.TypeScaleBothEnds:=sbeNone ; Measure5.Left:=47; Measure5.Width:=800;
    Measure6.MarginHorizontalRight:= 0; Measure6.MarginHorizontalLeft:= 0; Measure6.TypeFigureBothEnds:=fbeNone ; Measure6.TypeScaleBothEnds:=sbeNone ; Measure6.Left:=47; Measure6.Width:=800;
  end
  else
  begin
    Measure1.MarginHorizontalRight:=15; Measure1.MarginHorizontalLeft:=15; Measure1.TypeFigureBothEnds:=fbeExist; Measure1.TypeScaleBothEnds:=sbeExist; Measure1.Left:=32; Measure1.Width:=830;
    Measure2.MarginHorizontalRight:=15; Measure2.MarginHorizontalLeft:=15; Measure2.TypeFigureBothEnds:=fbeExist; Measure2.TypeScaleBothEnds:=sbeExist; Measure2.Left:=32; Measure2.Width:=830;
    Measure3.MarginHorizontalRight:=15; Measure3.MarginHorizontalLeft:=15; Measure3.TypeFigureBothEnds:=fbeExist; Measure3.TypeScaleBothEnds:=sbeExist; Measure3.Left:=32; Measure3.Width:=830;
    Measure4.MarginHorizontalRight:=15; Measure4.MarginHorizontalLeft:=15; Measure4.TypeFigureBothEnds:=fbeExist; Measure4.TypeScaleBothEnds:=sbeExist; Measure4.Left:=32; Measure4.Width:=830;
    Measure5.MarginHorizontalRight:=15; Measure5.MarginHorizontalLeft:=15; Measure5.TypeFigureBothEnds:=fbeExist; Measure5.TypeScaleBothEnds:=sbeExist; Measure5.Left:=32; Measure5.Width:=830;
    Measure6.MarginHorizontalRight:=15; Measure6.MarginHorizontalLeft:=15; Measure6.TypeFigureBothEnds:=fbeExist; Measure6.TypeScaleBothEnds:=sbeExist; Measure6.Left:=32; Measure6.Width:=830;
  end;

  redisplay(sender);
end;

procedure TFormMeasure05HowMuchLength.RadioGroupLineClick(Sender: TObject);
begin
  case RadioGroupLine.ItemIndex of
    0:begin
        Measure1.TypeScaleInterval:=si01;
        Measure2.TypeScaleInterval:=si01;
        Measure3.TypeScaleInterval:=si01;
        Measure4.TypeScaleInterval:=si01;
        Measure5.TypeScaleInterval:=si01;
        Measure6.TypeScaleInterval:=si01;
        sRadioGroupLine:=':1mm, ';
      end;
    1:begin
        Measure1.TypeScaleInterval:=si02;
        Measure2.TypeScaleInterval:=si02;
        Measure3.TypeScaleInterval:=si02;
        Measure4.TypeScaleInterval:=si02;
        Measure5.TypeScaleInterval:=si02;
        Measure6.TypeScaleInterval:=si02;
        sRadioGroupLine:=':2mm, ';
      end;
    2:begin
        Measure1.TypeScaleInterval:=si05;
        Measure2.TypeScaleInterval:=si05;
        Measure3.TypeScaleInterval:=si05;
        Measure4.TypeScaleInterval:=si05;
        Measure5.TypeScaleInterval:=si05;
        Measure6.TypeScaleInterval:=si05;
        sRadioGroupLine:=':5mm, ';
      end;
    3:begin
        Measure1.TypeScaleInterval:=si10;
        Measure2.TypeScaleInterval:=si10;
        Measure3.TypeScaleInterval:=si10;
        Measure4.TypeScaleInterval:=si10;
        Measure5.TypeScaleInterval:=si10;
        Measure6.TypeScaleInterval:=si10;
        sRadioGroupLine:=':10mm, ';
      end;
  end;
  redisplay(sender);
end;

procedure TFormMeasure05HowMuchLength.RadioGroupUnitClick(Sender: TObject);
begin
  case RadioGroupUnit.ItemIndex of
    0:begin
        Measure1.TypeUnitKind:=ukJapanese;
        Measure2.TypeUnitKind:=ukJapanese;
        Measure3.TypeUnitKind:=ukJapanese;
        Measure4.TypeUnitKind:=ukJapanese;
        Measure5.TypeUnitKind:=ukJapanese;
        Measure6.TypeUnitKind:=ukJapanese;
        LabelAnswer1.caption:='        Z`[g';
        LabelAnswer2.caption:='        Z`[g';
        LabelAnswer3.caption:='        Z`[g';
        LabelAnswer4.caption:='        Z`[g';
        LabelAnswer5.caption:='        Z`[g';
        LabelAnswer6.caption:='        Z`[g';
        sMeasureTypeUnitKind:='P:Z`[g';
        Label001.caption:='  ';
        Label00.Caption:='Z`[gł傤B';
      end;
    1:begin
        Measure1.TypeUnitKind:=ukEnglish;
        Measure2.TypeUnitKind:=ukEnglish;
        Measure3.TypeUnitKind:=ukEnglish;
        Measure4.TypeUnitKind:=ukEnglish;
        Measure5.TypeUnitKind:=ukEnglish;
        Measure6.TypeUnitKind:=ukEnglish;
        LabelAnswer1.caption:='                    cm';
        LabelAnswer2.caption:='                    cm';
        LabelAnswer3.caption:='                    cm';
        LabelAnswer4.caption:='                    cm';
        LabelAnswer5.caption:='                    cm';
        LabelAnswer6.caption:='                    cm';
        sMeasureTypeUnitKind:='P:cm';
        Label001.caption:='  ';
        Label00.Caption:='cmł傤B';
      end;
    2:begin
        Measure1.TypeUnitKind:=ukEnglish;
        Measure2.TypeUnitKind:=ukEnglish;
        Measure3.TypeUnitKind:=ukEnglish;
        Measure4.TypeUnitKind:=ukEnglish;
        Measure5.TypeUnitKind:=ukEnglish;
        Measure6.TypeUnitKind:=ukEnglish;
        LabelAnswer1.caption:='        cm     @  mm';
        LabelAnswer2.caption:='        cm     @  mm';
        LabelAnswer3.caption:='        cm     @  mm';
        LabelAnswer4.caption:='        cm     @  mm';
        LabelAnswer5.caption:='        cm     @  mm';
        LabelAnswer6.caption:='        cm     @  mm';
        sMeasureTypeUnitKind:='P:cm';
        Label001.caption:='  ';
        Label00.Caption:='͂ł傤B';
      end;
    3:begin
        Measure1.TypeUnitKind:=ukNone;
        Measure2.TypeUnitKind:=ukNone;
        Measure3.TypeUnitKind:=ukNone;
        Measure4.TypeUnitKind:=ukNone;
        Measure5.TypeUnitKind:=ukNone;
        Measure6.TypeUnitKind:=ukNone;
        LabelAnswer1.caption:='             @    ';
        LabelAnswer2.caption:='             @    ';
        LabelAnswer3.caption:='             @    ';
        LabelAnswer4.caption:='             @    ';
        LabelAnswer5.caption:='             @    ';
        LabelAnswer6.caption:='             @    ';
        sMeasureTypeUnitKind:='P:Ȃ';
        Label001.caption:='  ';
        Label00.Caption:='͂ł傤B';
      end;
  end;
  redisplay(sender);
end;

procedure TFormMeasure05HowMuchLength.RadioGroupBarColorClick(Sender: TObject);
begin
  case RadioGroupBarColor.ItemIndex of
    0:begin
        Measure1.BarColor:= clRed;
        Measure2.BarColor:= clRed;
        Measure3.BarColor:= clRed;
        Measure4.BarColor:= clRed;
        Measure5.BarColor:= clRed;
        Measure6.BarColor:= clRed;
        sBarColor:='_̐F:, ';
      end;
    1:begin
        Measure1.BarColor:= clBlue;
        Measure2.BarColor:= clBlue;
        Measure3.BarColor:= clBlue;
        Measure4.BarColor:= clBlue;
        Measure5.BarColor:= clBlue;
        Measure6.BarColor:= clBlue;
        sBarColor:='_̐F:, ';
      end;
    2:begin
        Measure1.BarColor:= clSilver;
        Measure2.BarColor:= clSilver;
        Measure3.BarColor:= clSilver;
        Measure4.BarColor:= clSilver;
        Measure5.BarColor:= clSilver;
        Measure6.BarColor:= clSilver;
        sBarColor:='_̐F:, ';
      end;
    3:begin
        Measure1.BarColor:= clBlack;
        Measure2.BarColor:= clBlack;
        Measure3.BarColor:= clBlack;
        Measure4.BarColor:= clBlack;
        Measure5.BarColor:= clBlack;
        Measure6.BarColor:= clBlack;
        sBarColor:='_̐F:, ';
      end;
    4:begin
        Measure1.BarColor:= clGray;
        Measure2.BarColor:= clGray;
        Measure3.BarColor:= clGray;
        Measure4.BarColor:= clGray;
        Measure5.BarColor:= clGray;
        Measure6.BarColor:= clGray;
        sBarColor:='_̐F:D, ';
      end;
  end;
  redisplay(sender);
end;

procedure TFormMeasure05HowMuchLength.SpinEditMeasureMaxChange(Sender: TObject);
begin
  Measure1.ScaleMax:=SpinEditMeasureMax.Value;
  Measure2.ScaleMax:=SpinEditMeasureMax.Value;
  Measure3.ScaleMax:=SpinEditMeasureMax.Value;
  Measure4.ScaleMax:=SpinEditMeasureMax.Value;
  Measure5.ScaleMax:=SpinEditMeasureMax.Value;
  Measure6.ScaleMax:=SpinEditMeasureMax.Value;
  SpinEditMMMax.MaxValue:=SpinEditMeasureMax.Value;
  sSpinEditMeasureMax:='`'+inttostr(SpinEditMeasureMax.value)+'mm, ';
  redisplay(sender);
  renew(sender);
end;

procedure TFormMeasure05HowMuchLength.RadioGroupBackGroundColorClick(Sender: TObject);
begin
  if RadioGroupBackGroundColor.ItemIndex=0
  then
  begin
    Measure1.BoardColor:=clBtnFace;
    Measure2.BoardColor:=clBtnFace;
    Measure3.BoardColor:=clBtnFace;
    Measure4.BoardColor:=clBtnFace;
    Measure5.BoardColor:=clBtnFace;
    Measure6.BoardColor:=clBtnFace;
    sBoardColor:='Ղ̐F:clBtnFace,';
  end
  else
  begin
    Measure1.BoardColor:=clWhite;
    Measure2.BoardColor:=clWhite;
    Measure3.BoardColor:=clWhite;
    Measure4.BoardColor:=clWhite;
    Measure5.BoardColor:=clWhite;
    Measure6.BoardColor:=clWhite;
    sBoardColor:='Ղ̐F:clWhite,';
  end;
  redisplay(sender);
end;

procedure TFormMeasure05HowMuchLength.SpinEditMMMinChange(Sender: TObject);
begin
  if SpinEditMMMin.Value> SpinEditMMMin.MaxValue then SpinEditMMMin.Value:=SpinEditMMMin.MaxValue;
  if SpinEditMMMin.Value< SpinEditMeasureMin.Value then SpinEditMMMin.Value:=SpinEditMeasureMin.Value;
  if (SpinEditMMMax.Value- SpinEditMMMin.Value) /Division< 1 then
  begin
    SpinEditMMMin.Value:= SpinEditMMMin.Value-Division;
  end;
  sSpinEditMMMin:='ŏl:'+inttostr(SpinEditMMMin.value)+', ';
  redisplay(sender);
  renew(sender);
end;

procedure TFormMeasure05HowMuchLength.SpinEditMMMaxChange(Sender: TObject);
begin
  if SpinEditMMMax.Value> SpinEditMMMax.MaxValue then SpinEditMMMax.Value:=SpinEditMMMax.MaxValue;
  if SpinEditMMMax.Value> SpinEditMeasureMax.Value then SpinEditMMMax.Value:=SpinEditMeasureMax.Value;
  if ((SpinEditMMMax.Value- SpinEditMMMin.Value) /Division)< 1 then
  begin
    SpinEditMMMax.Value:= SpinEditMMMax.Value+Division;
  end;
  sSpinEditMMMax:='_̒̍ől:'+inttostr(SpinEditMMMax.value)+', ';
  redisplay(sender);
  renew(sender);
end;

procedure TFormMeasure05HowMuchLength.CheckBoxMarginHorizontalClick(Sender: TObject);
begin
  if CheckBoxMarginHorizontal.Checked=true then
  begin
    Measure1.TypeFigureBothEnds:=fbeExist; Measure1.TypeScaleBothEnds:=sbeExist; Measure1.MarginHorizontalLeft:=15; Measure1.MarginHorizontalRight:=15; Measure1.Width:=830; Measure1.Left:=32;sCheckBoxMarginHorizontal:='[̗]:, ';
    Measure2.TypeFigureBothEnds:=fbeExist; Measure2.TypeScaleBothEnds:=sbeExist; Measure2.MarginHorizontalLeft:=15; Measure2.MarginHorizontalRight:=15; Measure2.Width:=830; Measure2.Left:=32;sCheckBoxMarginHorizontal:='[̗]:, ';
    Measure3.TypeFigureBothEnds:=fbeExist; Measure3.TypeScaleBothEnds:=sbeExist; Measure3.MarginHorizontalLeft:=15; Measure3.MarginHorizontalRight:=15; Measure3.Width:=830; Measure3.Left:=32;sCheckBoxMarginHorizontal:='[̗]:, ';
    Measure4.TypeFigureBothEnds:=fbeExist; Measure4.TypeScaleBothEnds:=sbeExist; Measure4.MarginHorizontalLeft:=15; Measure4.MarginHorizontalRight:=15; Measure4.Width:=830; Measure4.Left:=32;sCheckBoxMarginHorizontal:='[̗]:, ';
    Measure5.TypeFigureBothEnds:=fbeExist; Measure5.TypeScaleBothEnds:=sbeExist; Measure5.MarginHorizontalLeft:=15; Measure5.MarginHorizontalRight:=15; Measure5.Width:=830; Measure5.Left:=32;sCheckBoxMarginHorizontal:='[̗]:, ';
    Measure6.TypeFigureBothEnds:=fbeExist; Measure6.TypeScaleBothEnds:=sbeExist; Measure6.MarginHorizontalLeft:=15; Measure6.MarginHorizontalRight:=15; Measure6.Width:=830; Measure6.Left:=32;sCheckBoxMarginHorizontal:='[̗]:, ';
  end
  else
  begin
    Measure1.TypeFigureBothEnds:=fbeNone;  Measure1.TypeScaleBothEnds:=sbeNone;  Measure1.MarginHorizontalLeft:=0 ; Measure1.MarginHorizontalRight:=0 ; Measure1.Width:=800; Measure1.Left:=47;sCheckBoxMarginHorizontal:='[̗]:Ȃ, ';
    Measure2.TypeFigureBothEnds:=fbeNone;  Measure2.TypeScaleBothEnds:=sbeNone;  Measure2.MarginHorizontalLeft:=0 ; Measure2.MarginHorizontalRight:=0 ; Measure2.Width:=800; Measure2.Left:=47;sCheckBoxMarginHorizontal:='[̗]:Ȃ, ';
    Measure3.TypeFigureBothEnds:=fbeNone;  Measure3.TypeScaleBothEnds:=sbeNone;  Measure3.MarginHorizontalLeft:=0 ; Measure3.MarginHorizontalRight:=0 ; Measure3.Width:=800; Measure3.Left:=47;sCheckBoxMarginHorizontal:='[̗]:Ȃ, ';
    Measure4.TypeFigureBothEnds:=fbeNone;  Measure4.TypeScaleBothEnds:=sbeNone;  Measure4.MarginHorizontalLeft:=0 ; Measure4.MarginHorizontalRight:=0 ; Measure4.Width:=800; Measure4.Left:=47;sCheckBoxMarginHorizontal:='[̗]:Ȃ, ';
    Measure5.TypeFigureBothEnds:=fbeNone;  Measure5.TypeScaleBothEnds:=sbeNone;  Measure5.MarginHorizontalLeft:=0 ; Measure5.MarginHorizontalRight:=0 ; Measure5.Width:=800; Measure5.Left:=47;sCheckBoxMarginHorizontal:='[̗]:Ȃ, ';
    Measure6.TypeFigureBothEnds:=fbeNone;  Measure6.TypeScaleBothEnds:=sbeNone;  Measure6.MarginHorizontalLeft:=0 ; Measure6.MarginHorizontalRight:=0 ; Measure6.Width:=800; Measure6.Left:=47;sCheckBoxMarginHorizontal:='[̗]:Ȃ, ';
  end;
  redisplay(sender);
end;

procedure TFormMeasure05HowMuchLength.SpinEditMeasureMinChange(Sender: TObject);
begin
  Measure1.ScaleMin:=SpinEditMeasureMin.Value;
  Measure2.ScaleMin:=SpinEditMeasureMin.Value;
  Measure3.ScaleMin:=SpinEditMeasureMin.Value;
  Measure4.ScaleMin:=SpinEditMeasureMin.Value;
  Measure5.ScaleMin:=SpinEditMeasureMin.Value;
  Measure6.ScaleMin:=SpinEditMeasureMin.Value;
  sSpinEditMeasureMin:='ڐ͈̔:'+inttostr(SpinEditMeasureMin.value);
  redisplay(sender);
//  renew(sender);
end;

procedure TFormMeasure05HowMuchLength.SpinEditStandardChange(Sender: TObject);
begin
  sBarStartStandard:='_̎n_:'+inttostr(SpinEditStandard.value);
  redisplay(sender);
  Renew(Sender);
end;

procedure TFormMeasure05HowMuchLength.SpinEditWidthChange(Sender: TObject);
begin
  if SpinEditWidth.value>SpinEditStandard.value then SpinEditWidth.Value:=SpinEditStandard.value;
  sBarStartWidth:='}'+inttostr(SpinEditWidth.value)+'mm,';
  redisplay(sender);
  Renew(Sender);
end;

end.
